Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_retire.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_retire.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMealy_retire.cpp	(revision 88)
@@ -0,0 +1,193 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Commit_unit.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace commit_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Commit_unit::genMealy_retire"
+  void Commit_unit::genMealy_retire (void)
+  {
+    log_begin(Commit_unit,FUNCTION);
+    log_function(Commit_unit,FUNCTION,_name.c_str());
+
+    Tcontrol_t retire_val          [_param->_nb_rename_unit][_param->_max_nb_inst_retire];
+    uint32_t   num_inst_retire     [_param->_nb_rename_unit];
+    bool       can_retire          [_param->_nb_rename_unit];
+
+    Tcontrol_t spr_write_val       [_param->_nb_front_end][_param->_max_nb_context];
+    Tcontrol_t spr_write_sr_f_val  [_param->_nb_front_end][_param->_max_nb_context];
+    Tcontrol_t spr_write_sr_f      [_param->_nb_front_end][_param->_max_nb_context];
+    Tcontrol_t spr_write_sr_cy_val [_param->_nb_front_end][_param->_max_nb_context];
+    Tcontrol_t spr_write_sr_cy     [_param->_nb_front_end][_param->_max_nb_context];
+    Tcontrol_t spr_write_sr_ov_val [_param->_nb_front_end][_param->_max_nb_context];
+    Tcontrol_t spr_write_sr_ov     [_param->_nb_front_end][_param->_max_nb_context];
+
+
+    // Initialisation
+    for (uint32_t i=0; i<_param->_nb_bank; i++)
+      internal_BANK_RETIRE_VAL  [i] = false;
+
+    for (uint32_t i=0; i<_param->_nb_rename_unit; i++)
+      {
+	num_inst_retire [i] = 0;
+	can_retire      [i] = true ;
+	for (uint32_t j=0; j<_param->_nb_inst_retire[i]; j++)
+	  retire_val [i][j] = false;
+      }
+
+    for (uint32_t i=0; i<_param->_nb_front_end; ++i)
+      for (uint32_t j=0; j<_param->_nb_context[i]; ++j)
+	spr_write_val [i][j] = 0;
+
+    // Scan Top of each bank
+    for (uint32_t i=0; i<_param->_nb_bank; i++)
+      {
+	uint32_t num_bank = (reg_NUM_BANK_HEAD+i)%_param->_nb_bank;
+
+	if (not _rob[num_bank].empty())
+	  {
+	    // Scan all instruction in windows and test if instruction is speculative
+	    entry_t  * entry = _rob [num_bank].front();
+	    uint32_t   x     = entry->rename_unit_id;
+	    uint32_t   y     = num_inst_retire [x];
+	    
+	    if (can_retire [x] and // in-order
+		(y < _param->_nb_inst_retire [x]) and
+		PORT_READ(in_RETIRE_ACK [x][y])) // not busy
+	      {
+		rob_state_t state = entry->state;
+		
+		if ((state == ROB_END_OK  ) or 
+		    (state == ROB_END_KO  ) or 
+		    (state == ROB_END_MISS)//  or 
+// 		    (state == ROB_END_EXCEPTION)
+		    )
+		  {
+		    Tcontext_t         front_end_id   = entry->front_end_id;
+		    Tcontext_t         context_id     = entry->context_id;  
+		    Tcontrol_t         write_re       = entry->write_re;
+		    Tspecial_address_t num_reg_re_log = entry->num_reg_re_log;
+
+		    // if state is ok, when write flags in the SR regsiters
+		    bool spr_write_ack = true;
+
+		    if ((state == ROB_END_OK  ) and write_re)
+		      {
+			spr_write_ack = PORT_READ(in_SPR_WRITE_ACK [front_end_id][context_id]);
+
+			// retire_ack is set !!!
+			spr_write_val       [front_end_id][context_id] = 1;
+
+			Tspecial_data_t flags = entry->flags;
+
+			switch (num_reg_re_log)
+			  {
+			  case SPR_LOGIC_SR_F     : 
+			    {
+			      spr_write_sr_f_val  [front_end_id][context_id] = 1;
+			      spr_write_sr_f      [front_end_id][context_id] = (flags & FLAG_F )!=0;
+
+			      break;
+			    }
+			  case SPR_LOGIC_SR_CY_OV :
+			    {
+			      spr_write_sr_cy_val [front_end_id][context_id] = 1;
+			      spr_write_sr_ov_val [front_end_id][context_id] = 1;	
+			      spr_write_sr_cy     [front_end_id][context_id] = (flags & FLAG_CY)!=0;
+			      spr_write_sr_ov     [front_end_id][context_id] = (flags & FLAG_OV)!=0;
+			
+			      break;
+			    }
+			  default : 
+			    {
+#ifdef DEBUG_TEST
+			      throw ERRORMORPHEO(FUNCTION,_("Invalid num_reg_re_log.\n"));
+#endif
+			    }
+			  }
+		      }
+
+		    // find an instruction can be retire, and in order
+
+		    if (spr_write_ack)
+		      {
+			retire_val [x][y] = 1;
+			num_inst_retire [x] ++;
+			internal_BANK_RETIRE_VAL [num_bank] = true;
+		      }
+
+		    internal_BANK_RETIRE_NUM_RENAME_UNIT [num_bank] = x;
+		    internal_BANK_RETIRE_NUM_INST        [num_bank] = y;
+
+		    if (_param->_have_port_front_end_id)
+		    PORT_WRITE(out_RETIRE_FRONT_END_ID          [x][y], front_end_id                );
+		    if (_param->_have_port_context_id)
+		    PORT_WRITE(out_RETIRE_CONTEXT_ID            [x][y], context_id                  );
+// 		    PORT_WRITE(out_RETIRE_RENAME_UNIT_ID        [x][y], entry->rename_unit_id       );
+		    PORT_WRITE(out_RETIRE_EVENT_STATE           [x][y], entry->event_state          );
+		    PORT_WRITE(out_RETIRE_USE_STORE_QUEUE       [x][y], entry->use_store_queue      );
+		    PORT_WRITE(out_RETIRE_USE_LOAD_QUEUE        [x][y], entry->use_load_queue       );
+		    PORT_WRITE(out_RETIRE_STORE_QUEUE_PTR_WRITE [x][y], entry->store_queue_ptr_write);
+		    if (_param->_have_port_load_queue_ptr)
+		    PORT_WRITE(out_RETIRE_LOAD_QUEUE_PTR_WRITE  [x][y], entry->load_queue_ptr_write );
+		    PORT_WRITE(out_RETIRE_READ_RA               [x][y], entry->read_ra              );
+		    PORT_WRITE(out_RETIRE_NUM_REG_RA_PHY        [x][y], entry->num_reg_ra_phy       );
+		    PORT_WRITE(out_RETIRE_READ_RB               [x][y], entry->read_rb              );
+		    PORT_WRITE(out_RETIRE_NUM_REG_RB_PHY        [x][y], entry->num_reg_rb_phy       );
+		    PORT_WRITE(out_RETIRE_READ_RC               [x][y], entry->read_rc              );
+		    PORT_WRITE(out_RETIRE_NUM_REG_RC_PHY        [x][y], entry->num_reg_rc_phy       );
+		    PORT_WRITE(out_RETIRE_WRITE_RD              [x][y], entry->write_rd             );
+		    PORT_WRITE(out_RETIRE_NUM_REG_RD_LOG        [x][y], entry->num_reg_rd_log       );
+		    PORT_WRITE(out_RETIRE_NUM_REG_RD_PHY_OLD    [x][y], entry->num_reg_rd_phy_old   );
+		    PORT_WRITE(out_RETIRE_NUM_REG_RD_PHY_NEW    [x][y], entry->num_reg_rd_phy_new   );
+		    PORT_WRITE(out_RETIRE_WRITE_RE              [x][y], write_re                    );
+		    PORT_WRITE(out_RETIRE_NUM_REG_RE_LOG        [x][y], num_reg_re_log              );
+		    PORT_WRITE(out_RETIRE_NUM_REG_RE_PHY_OLD    [x][y], entry->num_reg_re_phy_old   );
+		    PORT_WRITE(out_RETIRE_NUM_REG_RE_PHY_NEW    [x][y], entry->num_reg_re_phy_new   );
+		  }
+	      }
+
+	    // Retire "in-order"
+	    can_retire [x] &= retire_val [x][y];
+	  }
+      }
+    
+    for (uint32_t i=0; i<_param->_nb_rename_unit; i++)
+      for (uint32_t j=0; j<_param->_nb_inst_retire[i]; j++)
+	PORT_WRITE(out_RETIRE_VAL [i][j],retire_val [i][j]);
+
+    for (uint32_t i=0; i<_param->_nb_front_end; ++i)
+      for (uint32_t j=0; j<_param->_nb_context[i]; ++j)
+	{
+	  PORT_WRITE(out_SPR_WRITE_VAL       [i][j], spr_write_val       [i][j]);
+	  PORT_WRITE(out_SPR_WRITE_SR_F_VAL  [i][j], spr_write_sr_f_val  [i][j]);
+	  PORT_WRITE(out_SPR_WRITE_SR_F      [i][j], spr_write_sr_f      [i][j]);
+	  PORT_WRITE(out_SPR_WRITE_SR_CY_VAL [i][j], spr_write_sr_cy_val [i][j]);
+	  PORT_WRITE(out_SPR_WRITE_SR_CY     [i][j], spr_write_sr_cy     [i][j]);
+	  PORT_WRITE(out_SPR_WRITE_SR_OV_VAL [i][j], spr_write_sr_ov_val [i][j]);
+	  PORT_WRITE(out_SPR_WRITE_SR_OV     [i][j], spr_write_sr_ov     [i][j]);
+	}
+
+    log_end(Commit_unit,FUNCTION);
+  };
+
+}; // end namespace commit_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMoore.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMoore.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_genMoore.cpp	(revision 88)
@@ -0,0 +1,158 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Commit_unit.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace commit_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Commit_unit::genMoore"
+  void Commit_unit::genMoore (void)
+  {
+    log_begin(Commit_unit,FUNCTION);
+    log_function(Commit_unit,FUNCTION,_name.c_str());
+
+    // ===================================================================
+    // =====[ REEXECUTE ]=================================================
+    // ===================================================================
+    {
+      Tcontrol_t val = false;
+
+      if (not _rob[reg_NUM_BANK_HEAD].empty())
+	{
+	  entry_t    * entry = _rob [reg_NUM_BANK_HEAD].front();
+	  rob_state_t  state = entry->state;
+
+	  val   = ((state == ROB_STORE_HEAD_OK) or
+		   (state == ROB_STORE_HEAD_KO));
+	  
+	  if (val)
+	    {
+	      if (_param->_have_port_context_id)
+  	      PORT_WRITE(out_REEXECUTE_CONTEXT_ID            [0], entry->context_id           );
+	      if (_param->_have_port_front_end_id)
+  	      PORT_WRITE(out_REEXECUTE_FRONT_END_ID          [0], entry->front_end_id         );
+	      if (_param->_have_port_rob_ptr  )
+  	      PORT_WRITE(out_REEXECUTE_PACKET_ID             [0], entry->ptr                  );
+	      PORT_WRITE(out_REEXECUTE_TYPE                  [0], entry->type                 );
+	      PORT_WRITE(out_REEXECUTE_STORE_QUEUE_PTR_WRITE [0], entry->store_queue_ptr_write);
+	      PORT_WRITE(out_REEXECUTE_OPERATION             [0], (state == ROB_STORE_HEAD_OK)?OPERATION_MEMORY_STORE_HEAD_OK:OPERATION_MEMORY_STORE_HEAD_KO);
+	    }
+	}
+ 
+      internal_REEXECUTE_VAL      [0] = val;
+      internal_REEXECUTE_NUM_BANK [0] = reg_NUM_BANK_HEAD;
+      
+      PORT_WRITE(out_REEXECUTE_VAL[0], internal_REEXECUTE_VAL [0]);
+    }
+
+    // ===================================================================
+    // =====[ BRANCH_COMPLETE ]===========================================
+    // ===================================================================
+    {
+      uint32_t nb_scan_bank = 0;
+
+      for (uint32_t i=0; i<_param->_nb_inst_branch_complete; i++)
+	{
+	  Tcontrol_t  val  = false;
+	  
+	  for (uint32_t j=nb_scan_bank; j<_param->_nb_bank; j++)
+	    {
+	      nb_scan_bank ++;
+
+	      uint32_t num_bank = (reg_NUM_BANK_HEAD+j)%_param->_nb_bank;
+	      
+	      if (not _rob [num_bank].empty())
+		{
+		  entry_t    * entry    = _rob [num_bank].front();
+		  rob_state_t  state    = entry->state;
+		  
+		  if (state == ROB_BRANCH_COMPLETE)
+		    {
+		      val = true;
+		      
+		      internal_BRANCH_COMPLETE_NUM_BANK           [i] = num_bank;
+		      
+		      if (_param->_have_port_context_id)
+		      PORT_WRITE(out_BRANCH_COMPLETE_CONTEXT_ID   [i], entry->context_id           );
+		      if (_param->_have_port_front_end_id)
+		      PORT_WRITE(out_BRANCH_COMPLETE_FRONT_END_ID [i], entry->front_end_id         );
+		      if (_param->_have_port_depth)
+		      PORT_WRITE(out_BRANCH_COMPLETE_DEPTH        [i], entry->depth                );
+		      PORT_WRITE(out_BRANCH_COMPLETE_ADDRESS      [i], entry->data_commit          );
+		      PORT_WRITE(out_BRANCH_COMPLETE_FLAG         [i], (entry->flags&FLAG_F)!=0    );
+		      
+		      break;
+		    }
+		}
+	    }
+
+	  internal_BRANCH_COMPLETE_VAL [i] = val;
+	  PORT_WRITE(out_BRANCH_COMPLETE_VAL [i], internal_BRANCH_COMPLETE_VAL [i]);
+	}
+    }
+
+    // ===================================================================
+    // =====[ UPDATE ]====================================================
+    // ===================================================================
+    {
+      Tcontrol_t val = false;
+
+      if (not _rob[reg_NUM_BANK_HEAD].empty())
+	{
+	  entry_t    * entry = _rob [reg_NUM_BANK_HEAD].front();
+	  rob_state_t  state = entry->state;
+
+	  val   = (state == ROB_END_EXCEPTION);
+	  
+	  if (val)
+	    {
+	      throw ERRORMORPHEO(FUNCTION,_("Moore : exception is not yet supported (Coming Soon).\n"));
+	    }
+	}
+    }
+
+//   public    : SC_OUT(Tcontrol_t         )   * out_UPDATE_VAL                        ;
+//   public    : SC_IN (Tcontrol_t         )   *  in_UPDATE_ACK                        ;
+//   public    : SC_OUT(Tcontext_t         )   * out_UPDATE_CONTEXT_ID                 ;
+//   public    : SC_OUT(Tcontext_t         )   * out_UPDATE_FRONT_END_ID               ;
+//   public    : SC_OUT(Tdepth_t           )   * out_UPDATE_DEPTH                      ;
+//   public    : SC_OUT(Tevent_type_t      )   * out_UPDATE_TYPE                       ;
+//   public    : SC_OUT(Tcontrol_t         )   * out_UPDATE_IS_DELAY_SLOT              ;
+//   public    : SC_OUT(Taddress_t         )   * out_UPDATE_ADDRESS                    ;
+//   public    : SC_OUT(Taddress_t         )   * out_UPDATE_ADDRESS_EPCR               ;
+//   public    : SC_OUT(Tcontrol_t         )   * out_UPDATE_ADDRESS_EEAR_VAL           ;
+//   public    : SC_OUT(Taddress_t         )   * out_UPDATE_ADDRESS_EEAR               ;
+ 
+    // ===================================================================
+    // =====[ NB_INST ]===================================================
+    // ===================================================================
+    for (uint32_t i=0; i<_param->_nb_front_end; i++)
+      for (uint32_t j=0; j<_param->_nb_context [i]; j++)
+	{
+	  PORT_WRITE(out_NB_INST_COMMIT_ALL [i][j], reg_NB_INST_COMMIT_ALL [i][j]);
+	  PORT_WRITE(out_NB_INST_COMMIT_MEM [i][j], reg_NB_INST_COMMIT_MEM [i][j]);
+	}
+
+
+    log_end(Commit_unit,FUNCTION);
+  };
+
+}; // end namespace commit_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_statistics_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_statistics_allocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_statistics_allocation.cpp	(revision 88)
@@ -0,0 +1,102 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Commit_unit.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace commit_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Commit_unit::statistics_allocation"
+  void Commit_unit::statistics_allocation (morpheo::behavioural::Parameters_Statistics * param_statistics)
+  {
+    log_begin(Commit_unit,FUNCTION);
+
+    _stat = new Stat (static_cast<std::string>(_name),
+		      "Commit_unit",
+		      param_statistics);
+
+    _stat_nb_inst_insert                = new counter_t * [_param->_nb_rename_unit];
+    _stat_nb_inst_retire                = new counter_t * [_param->_nb_rename_unit];
+    _stat_bank_nb_inst                  = new counter_t * [_param->_nb_bank];
+    
+    {
+      std::string sum_nb_inst_insert = "";
+      std::string sum_nb_inst_retire = "";
+
+      for (uint32_t i=0; i<_param->_nb_rename_unit; i++)
+	{
+	  _stat_nb_inst_insert [i] = _stat->create_variable("nb_inst_insert_"+toString(i));
+	  _stat_nb_inst_retire [i] = _stat->create_variable("nb_inst_retire_"+toString(i));
+	  
+	  _stat->create_expr_average_by_cycle("average_use_interface_insert_"+toString(i), "nb_inst_insert_"+toString(i), "", toString(_("Average instruction by cycle on insert interface (rename_unit %d)"),i));
+	  _stat->create_expr_average_by_cycle("average_use_interface_retire_"+toString(i), "nb_inst_retire_"+toString(i), "", toString(_("Average instruction by cycle on retire interface (rename_unit %d)"),i));
+	  _stat->create_expr_percent         ("percent_use_interface_insert_"+toString(i) , "average_use_interface_insert_"+toString(i), toString(_param->_nb_inst_insert [i]), toString(_("Percent usage of insert interface (rename_unit %d)"),i));
+	  _stat->create_expr_percent         ("percent_use_interface_retire_"+toString(i) , "average_use_interface_retire_"+toString(i), toString(_param->_nb_inst_retire [i]), toString(_("Percent usage of retire interface (rename_unit %d)"),i));
+
+	  if (i == 0)
+            {
+              sum_nb_inst_insert = "nb_inst_insert_"+toString(i);
+              sum_nb_inst_retire = "nb_inst_retire_"+toString(i);
+            }
+          else
+            {
+              sum_nb_inst_insert = "+ nb_inst_insert_"+toString(i) + " " +sum_nb_inst_insert;
+              sum_nb_inst_retire = "+ nb_inst_retire_"+toString(i) + " " +sum_nb_inst_retire;
+            }
+	}
+
+      _stat->create_expr_average_by_cycle("average_inst_insert", sum_nb_inst_insert, "", _("Average instruction insert by cycle"));
+      _stat->create_expr_average_by_cycle("average_inst_retire", sum_nb_inst_retire, "", _("Average instruction retire by cycle"));
+    }
+
+    _stat_nb_inst_commit = _stat->create_variable("nb_inst_commit");
+    _stat->create_expr_average_by_cycle("average_use_interface_commit","nb_inst_commit", "", _("Average instruction by cycle on commit interface"));
+    _stat->create_expr_percent         ("percent_use_interface_commit", "average_use_interface_commit", toString(_param->_nb_inst_commit), _("Percent usage of commit interface"));
+
+    _stat_nb_inst_commit_conflit_access = _stat->create_variable("nb_inst_commit_conflit_access");
+    _stat->create_expr_average_by_cycle("average_use_interface_commit_conflit_access","nb_inst_commit_conflit_access", "", _("Average access conflit by cycle on commit interface"));
+    _stat->create_expr_percent         ("percent_use_interface_commit_conflit_access","average_use_interface_commit_conflit_access", "average_use_interface_commit", _("Percent access conflit on commit interface"));
+
+    // bank/queue occupation
+    {
+      std::string sum_bank_nb_inst = "";
+      for (uint32_t i=0; i<_param->_nb_bank; i++)
+        {
+          _stat_bank_nb_inst [i] = _stat->create_variable("bank_nb_inst_"+toString(i));
+          
+          _stat->create_expr_average_by_cycle("average_occupation_bank_"+toString(i), "bank_nb_inst_"+toString(i), "", toString(_("Average instruction by cycle (bank %d)"),i));
+          _stat->create_expr_percent         ("percent_occupation_bank_"+toString(i), "average_occupation_bank_"+toString(i), toString(_param->_size_bank), toString(_("Percent occupation of bank (bank %d)"),i));
+          
+          if (i == 0)
+            sum_bank_nb_inst = "bank_nb_inst_"+toString(i);
+          else
+            sum_bank_nb_inst = "+ bank_nb_inst_"+toString(i) + " " +sum_bank_nb_inst;
+        }
+      
+      _stat->create_expr_average_by_cycle("average_occupation_bank", sum_bank_nb_inst, "", _("Average instruction by cycle (all bank)"));
+      _stat->create_expr_percent         ("percent_occupation_bank" , "average_occupation_bank", toString(_param->_size_queue), _("Percent occupation of Re-Order-Buffer (all bank)"));
+    }
+
+
+    log_end(Commit_unit,FUNCTION);
+  };
+
+}; // end namespace commit_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_statistics_deallocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_statistics_deallocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit_statistics_deallocation.cpp	(revision 88)
@@ -0,0 +1,43 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Commit_unit.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace commit_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Commit_unit::statistics_deallocation"
+  void Commit_unit::statistics_deallocation (void)
+  {
+    log_begin(Commit_unit,FUNCTION);
+
+    log_printf(INFO,Commit_unit,FUNCTION,_("<%s> : Generate Statistics file"),_name.c_str());
+
+    delete _stat;
+
+    delete [] _stat_nb_inst_insert;
+    delete [] _stat_nb_inst_retire;
+    delete [] _stat_bank_nb_inst;
+    
+    log_end(Commit_unit,FUNCTION);
+  };
+
+}; // end namespace commit_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
